# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2017_09_01_preview
  module Models
    #
    # SSIS package location.
    #
    class SSISPackageLocation

      include MsRestAzure

      # @return The SSIS package path. Type: string (or Expression with
      # resultType string).
      attr_accessor :package_path

      # @return [SsisPackageLocationType] The type of SSIS package location.
      # Possible values include: 'SSISDB', 'File'
      attr_accessor :type

      # @return [SecretBase] Password of the package.
      attr_accessor :package_password

      # @return [SSISAccessCredential] The package access credential.
      attr_accessor :access_credential

      # @return The configuration file of the package execution. Type: string
      # (or Expression with resultType string).
      attr_accessor :configuration_path


      #
      # Mapper for SSISPackageLocation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SSISPackageLocation',
          type: {
            name: 'Composite',
            class_name: 'SSISPackageLocation',
            model_properties: {
              package_path: {
                client_side_validation: true,
                required: true,
                serialized_name: 'packagePath',
                type: {
                  name: 'Object'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              package_password: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.packagePassword',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'SecretBase',
                  class_name: 'SecretBase'
                }
              },
              access_credential: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.accessCredential',
                type: {
                  name: 'Composite',
                  class_name: 'SSISAccessCredential'
                }
              },
              configuration_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.configurationPath',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
