# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Execution policy for an activity.
    #
    class ActivityPolicy

      include MsRestAzure

      # @return Unmatched properties from the message are deserialized this
      # collection
      attr_accessor :additional_properties

      # @return Specifies the timeout for the activity to run. The default
      # timeout is 7 days. Type: string (or Expression with resultType string),
      # pattern: ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).
      attr_accessor :timeout

      # @return Maximum ordinary retry attempts. Default is 0. Type: integer
      # (or Expression with resultType integer), minimum: 0.
      attr_accessor :retry_property

      # @return [Integer] Interval between each retry attempt (in seconds). The
      # default is 30 sec.
      attr_accessor :retry_interval_in_seconds

      # @return [Boolean] When set to true, Input from activity is considered
      # as secure and will not be logged to monitoring.
      attr_accessor :secure_input

      # @return [Boolean] When set to true, Output from activity is considered
      # as secure and will not be logged to monitoring.
      attr_accessor :secure_output


      #
      # Mapper for ActivityPolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ActivityPolicy',
          type: {
            name: 'Composite',
            class_name: 'ActivityPolicy',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              timeout: {
                client_side_validation: true,
                required: false,
                serialized_name: 'timeout',
                type: {
                  name: 'Object'
                }
              },
              retry_property: {
                client_side_validation: true,
                required: false,
                serialized_name: 'retry',
                type: {
                  name: 'Object'
                }
              },
              retry_interval_in_seconds: {
                client_side_validation: true,
                required: false,
                serialized_name: 'retryIntervalInSeconds',
                constraints: {
                  InclusiveMaximum: 86400,
                  InclusiveMinimum: 30
                },
                type: {
                  name: 'Number'
                }
              },
              secure_input: {
                client_side_validation: true,
                required: false,
                serialized_name: 'secureInput',
                type: {
                  name: 'Boolean'
                }
              },
              secure_output: {
                client_side_validation: true,
                required: false,
                serialized_name: 'secureOutput',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
