# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Azure ML Execute Pipeline activity.
    #
    class AzureMLExecutePipelineActivity < ExecutionActivity

      include MsRestAzure


      def initialize
        @type = "AzureMLExecutePipeline"
      end

      attr_accessor :type

      # @return ID of the published Azure ML pipeline. Type: string (or
      # Expression with resultType string).
      attr_accessor :ml_pipeline_id

      # @return ID of the published Azure ML pipeline endpoint. Type: string
      # (or Expression with resultType string).
      attr_accessor :ml_pipeline_endpoint_id

      # @return Version of the published Azure ML pipeline endpoint. Type:
      # string (or Expression with resultType string).
      attr_accessor :version

      # @return Run history experiment name of the pipeline run. This
      # information will be passed in the ExperimentName property of the
      # published pipeline execution request. Type: string (or Expression with
      # resultType string).
      attr_accessor :experiment_name

      # @return Key,Value pairs to be passed to the published Azure ML pipeline
      # endpoint. Keys must match the names of pipeline parameters defined in
      # the published pipeline. Values will be passed in the
      # ParameterAssignments property of the published pipeline execution
      # request. Type: object with key value pairs (or Expression with
      # resultType object).
      attr_accessor :ml_pipeline_parameters

      # @return Dictionary used for changing data path assignments without
      # retraining. Values will be passed in the dataPathAssignments property
      # of the published pipeline execution request. Type: object with key
      # value pairs (or Expression with resultType object).
      attr_accessor :data_path_assignments

      # @return The parent Azure ML Service pipeline run id. This information
      # will be passed in the ParentRunId property of the published pipeline
      # execution request. Type: string (or Expression with resultType string).
      attr_accessor :ml_parent_run_id

      # @return Whether to continue execution of other steps in the PipelineRun
      # if a step fails. This information will be passed in the
      # continueOnStepFailure property of the published pipeline execution
      # request. Type: boolean (or Expression with resultType boolean).
      attr_accessor :continue_on_step_failure


      #
      # Mapper for AzureMLExecutePipelineActivity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureMLExecutePipeline',
          type: {
            name: 'Composite',
            class_name: 'AzureMLExecutePipelineActivity',
            model_properties: {
              additional_properties: {
                client_side_validation: true,
                required: false,
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              depends_on: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dependsOn',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ActivityDependencyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ActivityDependency'
                      }
                  }
                }
              },
              user_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userProperties',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UserPropertyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UserProperty'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              linked_service_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'linkedServiceName',
                type: {
                  name: 'Composite',
                  class_name: 'LinkedServiceReference'
                }
              },
              policy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'policy',
                type: {
                  name: 'Composite',
                  class_name: 'ActivityPolicy'
                }
              },
              ml_pipeline_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.mlPipelineId',
                type: {
                  name: 'Object'
                }
              },
              ml_pipeline_endpoint_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.mlPipelineEndpointId',
                type: {
                  name: 'Object'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.version',
                type: {
                  name: 'Object'
                }
              },
              experiment_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.experimentName',
                type: {
                  name: 'Object'
                }
              },
              ml_pipeline_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.mlPipelineParameters',
                type: {
                  name: 'Object'
                }
              },
              data_path_assignments: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.dataPathAssignments',
                type: {
                  name: 'Object'
                }
              },
              ml_parent_run_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.mlParentRunId',
                type: {
                  name: 'Object'
                }
              },
              continue_on_step_failure: {
                client_side_validation: true,
                required: false,
                serialized_name: 'typeProperties.continueOnStepFailure',
                type: {
                  name: 'Object'
                }
              }
            }
          }
        }
      end
    end
  end
end
