# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Definition of CMK for the factory.
    #
    class EncryptionConfiguration

      include MsRestAzure

      # @return [String] The name of the key in Azure Key Vault to use as
      # Customer Managed Key.
      attr_accessor :key_name

      # @return [String] The url of the Azure Key Vault used for CMK.
      attr_accessor :vault_base_url

      # @return [String] The version of the key used for CMK. If not provided,
      # latest version will be used.
      attr_accessor :key_version

      # @return [CMKIdentityDefinition] User assigned identity to use to
      # authenticate to customer's key vault. If not provided Managed Service
      # Identity will be used.
      attr_accessor :identity


      #
      # Mapper for EncryptionConfiguration class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EncryptionConfiguration',
          type: {
            name: 'Composite',
            class_name: 'EncryptionConfiguration',
            model_properties: {
              key_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'keyName',
                type: {
                  name: 'String'
                }
              },
              vault_base_url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'vaultBaseUrl',
                type: {
                  name: 'String'
                }
              },
              key_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyVersion',
                type: {
                  name: 'String'
                }
              },
              identity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'identity',
                type: {
                  name: 'Composite',
                  class_name: 'CMKIdentityDefinition'
                }
              }
            }
          }
        }
      end
    end
  end
end
