# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataFactory::Mgmt::V2018_06_01
  module Models
    #
    # Details about an operation related to metrics.
    #
    class OperationMetricSpecification

      include MsRestAzure

      # @return [String] The name of the metric.
      attr_accessor :name

      # @return [String] Localized display name of the metric.
      attr_accessor :display_name

      # @return [String] The description of the metric.
      attr_accessor :display_description

      # @return [String] The unit that the metric is measured in.
      attr_accessor :unit

      # @return [String] The type of metric aggregation.
      attr_accessor :aggregation_type

      # @return [String] Whether or not the service is using regional MDM
      # accounts.
      attr_accessor :enable_regional_mdm_account

      # @return [String] The name of the MDM account.
      attr_accessor :source_mdm_account

      # @return [String] The name of the MDM namespace.
      attr_accessor :source_mdm_namespace

      # @return [Array<OperationMetricAvailability>] Defines how often data for
      # metrics becomes available.
      attr_accessor :availabilities

      # @return [Array<OperationMetricDimension>] Defines the metric dimension.
      attr_accessor :dimensions


      #
      # Mapper for OperationMetricSpecification class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OperationMetricSpecification',
          type: {
            name: 'Composite',
            class_name: 'OperationMetricSpecification',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              display_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'displayDescription',
                type: {
                  name: 'String'
                }
              },
              unit: {
                client_side_validation: true,
                required: false,
                serialized_name: 'unit',
                type: {
                  name: 'String'
                }
              },
              aggregation_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'aggregationType',
                type: {
                  name: 'String'
                }
              },
              enable_regional_mdm_account: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enableRegionalMdmAccount',
                type: {
                  name: 'String'
                }
              },
              source_mdm_account: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceMdmAccount',
                type: {
                  name: 'String'
                }
              },
              source_mdm_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceMdmNamespace',
                type: {
                  name: 'String'
                }
              },
              availabilities: {
                client_side_validation: true,
                required: false,
                serialized_name: 'availabilities',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'OperationMetricAvailabilityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'OperationMetricAvailability'
                      }
                  }
                }
              },
              dimensions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dimensions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'OperationMetricDimensionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'OperationMetricDimension'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
